/* oscdraw.c
 * 
 * Licensed under WTFPL
 * (c) 2010 LexsZero <lexszero@gmail.com>
 *
 * Modified oscdraw, optimized for playing thousands of frames, named like 00001234.points
 * Discretization rate used for determining length of every frame picture (assuming 30 fps)
 *
 * Sorry for hardcoded image size :3
 *
 * Usage:	oscdraw <num_frames> <discr_rate>
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <string.h>
#include <inttypes.h>

typedef struct {
	int x, y;
} point;

int main(int argc, char **argv) {
	int i, n = 0, k, kk,
		alloced = 1000; // predict we have less than 1000 points
	
	point *p = malloc(sizeof(point) * alloced);
	point min = { 0, 0 }, max = { 4500, 3300 }, t, d;
	point *cur;

	uint16_t tx, ty;

	FILE *F;

	char filename[17];
	filename[16] = 0;

for (k = 1; k <= atoi(argv[1]); k++) {
	
	sprintf(filename, "%08i.points", k);
	fprintf(stderr, "%s\n", filename);
	F = fopen(filename, "r");
	
	n = 0;
	while (fscanf(F, "%i %i", &(t.x), &(t.y)) != EOF) {
		memcpy(p + n++, &t, sizeof(point));
		if (n >= alloced) {
			alloced += 1000;
			p = realloc(p, sizeof(point) * alloced);
		}
	}

	fclose(F);

	fprintf(stderr, "count %i\n", n);
	
	if (n != 0) {
		kk = 0;
		i = 0;
		while (kk < atoi(argv[2])/30) {
			cur = p + i;
			tx = (uint16_t) (cur->x/4500.0*65535); 
			ty = (uint16_t) (cur->y/3300.0*65535); 
			//fprintf(stderr, "%i %i\n", tx, ty);
			write(1, &tx, 2);
			write(1, &ty, 2);
			kk++;
			i = (i+1) % n;
		}
	}
	else {
		tx = ty = 0;
		for (i = 0; i < atoi(argv[2])/30; i++) {
				write(1, &tx, 2);
				write(1, &ty, 2);
		}
	}
}
	free(p);
	return 0;
}
